//  Definitions for Tape drives
//  ---------------------------

//  Basic definitions.

#include "aspi.h"

#pragma pack(1)

#ifndef BYTE_DEFINED
#define BYTE_DEFINED 1
typedef unsigned char BYTE;		// unsigned 8-bit
typedef unsigned int WORD;		// unsigned 16-bit
typedef unsigned long DWORD;		// unsigned 32-bit
typedef void _far FPTR;			// far pointer
#define addr(x) (&(x))			// address-of operator
#define TRUE 1				// affirmative
#define FALSE 0				// negative
#ifndef NULL
#define NULL (0)			// no pointer
#endif
#endif

//  Physical constants.

#define TAPE_RW_TIMEOUT 10		// timeout (seconds) for tape read/write
#define TAPE_POS_TIMEOUT 120		// timeout for positioning commands
#define TAPE_MODE_SENSE_RETRIES 4	// number of mode-sense retries
#define TAPE_REQUEST_SENSE_RETRIES 4	// number of request-sense retries

#define TAPE_READ_MODE 0		// for mount; mount for read
#define TAPE_WRITE_MODE 1		// for mount; mount for write
#define TAPE_QUERY_MODE 2		// for mount; query mount mode
#define TAPE_QUERY_VOLUME 3		// for mount; query volume number
#define TAPE_UNLOAD_MODE 4		// for mount; unload the tape

int GetTapes( void);
int TapeRequestSense( SCSI_REQUEST_SENSE_RESULTS *rsp, int TapeNo);
int TapeTestReady(  int mode, int TapeNo);
int TapeRewind( int TapeNo);
int TapeUnload( int TapeNo);
DWORD TapeReadPosition( int TapeNo);
int TapeSkipRelative( long Position, int TapeNo);
int TapeSkipFiles( long Position, int TapeNo);
int TapeSetBlock( WORD TapeBlockSize, int Mode, int TapeNo);
WORD TapeGetBlockSize( int TapeNo);
int TapeErase( int TapeNo);
int TapeRead( void _far *Buffer, WORD BufferSize, WORD *BytesRead, int TapeNo);
int TapeReadVariable( void _far *Buffer, WORD BufferSize, WORD *BytesRead,
		      int TapeNo);
int TapeWrite( void _far *Buffer, WORD BufferSize, int TapeNo);
int TapeClearIO( int TapeNo);
